/*
 * BobbyUtils.cpp
 *
 *  Created on: 24 janv. 2011
 *      Author: robot1
 */

#include "BobbyUtils.h"


double BobbyUtils::abs(double nb){
	return(nb>0?nb:-nb);
}

void* BobbyUtils::getSharedMemory(const char* filename, int memorySize) {
	int sharedMemId = shmget(ftok(filename, 1), memorySize, IPC_CREAT | 0666);
	return shmat(sharedMemId, NULL, 0);
}

int BobbyUtils::unsetSharedMemory(const void* shmaddr) {
	return shmdt(shmaddr);
}

int BobbyUtils::getSemaphore(const int semdef) {
	int semid = semget(semdef, 1, IPC_CREAT | 0666);
	return semid;
}

int BobbyUtils::initSemaphore(int semid) {
	return semctl(semid, 0, SETVAL, 1);
}

int BobbyUtils::removeSemaphore(int semid) {
	return semctl(semid, 0, IPC_RMID, 0);
}

int BobbyUtils::takeSemaphore(int semid) {
	sembuf semtake = { 0, -1, 0 };
	return semop(semid, &semtake, 1);
}

int BobbyUtils::checkSemaphore(int semid) {
	sembuf semtake = { 0, -1, IPC_NOWAIT };
	return semop(semid, &semtake, 1);
}

int BobbyUtils::giveSemaphore(int semid) {
	sembuf semgive = { 0, 1, 0 };
	return semop(semid, &semgive, 1);
}

mem_struct BobbyUtils::traitementInfos(s_position posBallon,
		s_position posK1avant, s_position posK1arriere, s_position posK2avant,
		s_position posK2arriere) {
	mem_struct result;
	result.posBalle = posBallon;

	s_position posTemp1 = { ((posK1avant.x + posK1arriere.x) / 2),
			((posK1avant.y + posK1arriere.y) / 2) };
	s_position posTemp2 = { ((posK2avant.x + posK2arriere.x) / 2),
			((posK2avant.y + posK2arriere.y) / 2) };

	if (posTemp1.x < posTemp2.x) {
		result.posK1 = posTemp1;
		result.posK2 = posTemp2;
		result.dirK1=s_direction {(posK1avant.x-posK1arriere.x),(posK1avant.y-posK1arriere.y)};
		result.dirK2=s_direction {(posK2avant.x-posK2arriere.x),(posK2avant.y-posK2arriere.y)};
	} else {
		result.posK1=posTemp2;
		result.posK2=posTemp1;
		result.dirK1=s_direction {(posK2avant.x-posK2arriere.x),(posK2avant.y-posK2arriere.y)};
		result.dirK2=s_direction {(posK1avant.x-posK1arriere.x),(posK1avant.y-posK1arriere.y)};
	}

return result;
}
BobbyUtils::BobbyUtils() {
	// TODO Auto-generated constructor stub

}

BobbyUtils::~BobbyUtils() {
	// TODO Auto-generated destructor stub
}
