/*
 * BobbyUtils.h
 *
 *  Created on: 24 janv. 2011
 *      Author: robot1
 */

#ifndef BOBBYUTILS_H_
#define BOBBYUTILS_H_

#include <iostream>
#include <sys/ipc.h>    /* ftok() */
#include <sys/shm.h>	/* shmget() */
#include <sys/sem.h>	/* semget() */
#include <sys/types.h>
#include <sys/wait.h>

#define STATE_MEMORY_FILENAME "stateMemory"
#define STATE_SEM_FILENAME 1337
#define STATE_SEM_VIDEOKILLER 1338
#define STATE_SEM_TFKILLER 1339
#define STATE_SEM_CONSOLE 1340
#define STATE_SEM_NEXTSTEP 1341
#define STATE_SEM_BOBBYKILLER 1342
struct s_imageSize {
	int longueur;
	int largeur;
};

struct s_position {
	int x;
	int y;
};
struct s_direction {
	int u;
	int v;
};

struct mem_struct {
	s_position posBalle;
	s_position posK1;
	s_direction dirK1;
	s_position posK2;
	s_direction dirK2;
};

static const int LONGUEUR_TERRAIN_Y = 640;
static const int LARGEUR_TERRAIN_X = 480;
static const int MILIEU_DE_TERRAIN = LONGUEUR_TERRAIN_Y / 2;
static const int MILIEU_DE_ZONE = LARGEUR_TERRAIN_X / 2;
static const int LIGNE_DEFENSE = MILIEU_DE_ZONE / 3;

class BobbyUtils {
public:
	static double abs(double);
	static void* getSharedMemory(const char* filename, int memorySize);
	static int unsetSharedMemory(const void*);
	static int getSemaphore(const int semdef);
	static int removeSemaphore(int semid);
	static int takeSemaphore(int semid);
	static int giveSemaphore(int semid);
	static int checkSemaphore(int semid);
	static int initSemaphore(int semid);
	static mem_struct traitementInfos(s_position posBalle,
			s_position posK1avant, s_position posK1arriere,
			s_position posK2avant, s_position posK2arriere);
	BobbyUtils();
	virtual ~BobbyUtils();
};

#endif /* BOBBYUTILS_H_ */
