/*
 * Stratege.cpp
 *
 *  Created on: 17 janv. 2011
 *      Author: robot1
 */

#include "Stratege.h"
#include <sys/shm.h>
#include <sys/sem.h>

Stratege::Stratege() {
	khep1 = new Rob(s1, 1);
	khep2 = new Rob(s2, 2);
	int lol = khep1->initializeCom();
	int lol2 = khep2->initializeCom();
	cout << lol << "||" << lol2 << endl;
	ballon = new Balle;
	etat_courant = AUCUN;
	strategie_courante = 0;
	bobbyKiller = BobbyUtils::getSemaphore(STATE_SEM_BOBBYKILLER);
	sm_console = BobbyUtils::getSemaphore(STATE_SEM_CONSOLE);
	videoKiller = BobbyUtils::getSemaphore(STATE_SEM_VIDEOKILLER);
	tacheFilleKiller = BobbyUtils::getSemaphore(STATE_SEM_TFKILLER);
	sm_protector = BobbyUtils::getSemaphore(STATE_SEM_FILENAME);

	sm_etatjeu = (mem_struct*) BobbyUtils::getSharedMemory(
			STATE_MEMORY_FILENAME, sizeof(mem_struct));

}

Stratege::~Stratege() {

	if (khep1 != NULL) {
		khep1->stop();
		delete khep1;
	}
	if (khep2 != NULL) {
		khep2->stop();
		delete khep2;
	}
	if (ballon != NULL) {
		delete ballon;
	}
}

void Stratege::EvaluerEtat() {

	int i = 0;
	ChangementStrat(REPLACEMENT);
	BobbyUtils::takeSemaphore(tacheFilleKiller);
	cout << "On prend le TFK depuis Eval" << endl;

	while (BobbyUtils::checkSemaphore(bobbyKiller) == -1) {
		i++;
		sleep(1);

		BobbyUtils::takeSemaphore(sm_console);
		std::cout << "Evaluation " << i << ": " << etat_courant << std::endl;
		BobbyUtils::giveSemaphore(sm_console);

		BobbyUtils::takeSemaphore(sm_protector);
		//std::cout << "On prend le token depuis Evaluer Etat" << std::endl;
		ballon->setPosition(sm_etatjeu->posBalle);
		khep1->setPosition(sm_etatjeu->posK1);
		khep2->setPosition(sm_etatjeu->posK2);
		khep1->setDirection(sm_etatjeu->dirK1);
		khep2->setDirection(sm_etatjeu->dirK2);
		BobbyUtils::giveSemaphore(sm_protector);
		//std::cout << "On rend le token depuis Evaluer Etat" << std::endl;

		Etat new_etat = REPLACEMENT;
		if (ballon->getDirection().v > -1) {
			if (ballon->getDirection().v < 5) {
				if (ballon->getPosition().y < MILIEU_DE_TERRAIN) {
					new_etat = ATTAQUE;
				}
			}
		} else if (ballon->getDirection().v < -2) {
			new_etat = DEFENSE;
		}

		if (etat_courant != new_etat) {
			etat_courant = new_etat;
			if (strategie_courante) {
				BobbyUtils::giveSemaphore(tacheFilleKiller);

				BobbyUtils::takeSemaphore(sm_console);
				cout << "On donne le TFK depuis Eval" << endl;
				BobbyUtils::giveSemaphore(sm_console);

				int status = 0;
				pid_t o = wait(&status);
				BobbyUtils::takeSemaphore(tacheFilleKiller);

				BobbyUtils::takeSemaphore(sm_console);
				cout << "On prend le TFK depuis Eval" << endl;
				BobbyUtils::giveSemaphore(sm_console);

				strategie_courante = ChangementStrat(etat_courant);
			} else {
				strategie_courante = ChangementStrat(etat_courant);
			}
		}
	}

	BobbyUtils::giveSemaphore(tacheFilleKiller);

	int status;
	pid_t o = wait(&status);
}

pid_t Stratege::ChangementStrat(Etat etat) {
	switch (etat) {
	case (ATTAQUE):
		strategie_courante = Attaque();

		BobbyUtils::takeSemaphore(sm_console);
		std::cout << "changement de strat pour Attaque" << std::endl;
		BobbyUtils::giveSemaphore(sm_console);

		break;
	case (DEFENSE):
		strategie_courante = Defense();

		BobbyUtils::takeSemaphore(sm_console);
		std::cout << "changement de strat pour Defense" << std::endl;
		BobbyUtils::giveSemaphore(sm_console);
		break;
	case (REPLACEMENT):
		strategie_courante = Replacement();

		BobbyUtils::takeSemaphore(sm_console);
		std::cout << "changement de strat pour Replacement" << std::endl;
		BobbyUtils::giveSemaphore(sm_console);

		break;

	}
	return strategie_courante;
}

pid_t Stratege::Attaque() {
	pid_t apid;

	if ((apid = fork()) == 0) {
		while (ballon->getDirection().v > 5) {
			usleep(1000);
			BobbyUtils::takeSemaphore(sm_protector);
			ballon->setPosition(sm_etatjeu->posBalle);
			BobbyUtils::giveSemaphore(sm_protector);
		}
		std::cout << "On Attaque" << std::endl;
		int indiceK = 0;
		BobbyUtils::takeSemaphore(sm_protector);
		//std::cout << "On prend le token depuis Attaque" << std::endl;
		ballon->setPosition(sm_etatjeu->posBalle);
		khep1->setPosition(sm_etatjeu->posK1);
		khep2->setPosition(sm_etatjeu->posK2);
		khep1->setDirection(sm_etatjeu->dirK1);
		khep2->setDirection(sm_etatjeu->dirK2);
		BobbyUtils::giveSemaphore(sm_protector);
		if (ballon->getPosition().x <= MILIEU_DE_ZONE) {
			indiceK = 1;
		} else {
			indiceK = 2;
		}

		switch (indiceK) {
		case (1):
			khep1->shoot(ballon->getPosition());
			break;
		case (2):
			khep2->shoot(ballon->getPosition());
			break;
		}

		BobbyUtils::takeSemaphore(tacheFilleKiller);
		BobbyUtils::takeSemaphore(sm_console);
		cout << "TFK Attaque pris" << endl;
		BobbyUtils::giveSemaphore(sm_console);

		BobbyUtils::giveSemaphore(tacheFilleKiller);

		BobbyUtils::takeSemaphore(sm_console);
		cout << "TFK Attaque rendu" << endl;
		BobbyUtils::giveSemaphore(sm_console);
		exit(0);

	} else {
		return apid;
	}
}

pid_t Stratege::Defense() {
	pid_t dpid;
	if ((dpid = fork()) == 0) {
		//		int x;
		//		int y = LIGNE_DEFENSE;
		//		x = ballon->getPosition().x + (ballon->getDirection().u
		//				* ((ballon->getPosition().y - y) / ballon->getDirection().v));
		//		x = abs(x);
		//
		//		while (x > LARGEUR_TERRAIN_X) {
		//			x = 2 * LARGEUR_TERRAIN_X - x;
		//			x = abs(x);
		//		}
		//		s_position dest = { x, y };
		int test = -1;
		while (test == -1) {
			BobbyUtils::takeSemaphore(sm_protector);
			ballon->setPosition(sm_etatjeu->posBalle);
			BobbyUtils::giveSemaphore(sm_protector);

			if (ballon->getPosition().x <= MILIEU_DE_ZONE) {
				khep1->moveDef(ballon->getPosition().x
						+ ballon->getDirection().u);
			} else {
				khep2->moveDef(ballon->getPosition().x
						+ ballon->getDirection().u);
			}
			test = BobbyUtils::checkSemaphore(tacheFilleKiller);
			usleep(10000);
		}

		BobbyUtils::takeSemaphore(sm_console);
		cout << "TFK Def pris" << endl;
		BobbyUtils::giveSemaphore(sm_console);

		BobbyUtils::giveSemaphore(tacheFilleKiller);

		BobbyUtils::takeSemaphore(sm_console);
		cout << "TFK Def rendu" << endl;
		BobbyUtils::giveSemaphore(sm_console);
		exit(0);
	} else {
		return dpid;
	}
}

pid_t Stratege::Replacement() {
	pid_t rpid;
	if ((rpid = fork()) == 0) {
		int xa;
		int xb;
		int y = LIGNE_DEFENSE;
		xa = round(2 * (MILIEU_DE_ZONE / 3));
		xb = round(4 * (MILIEU_DE_ZONE / 3));
		s_direction boutDeLigne = { 10, 0 };

		pid_t lolpid;
		if ((lolpid = fork()) == 0) {
			s_position dest1 = { xa, y };
			while (khep1->moveTo(dest1))
				;
			khep1->rotate(boutDeLigne);
			exit(0);
		} else {
			s_position dest2 = { xb, y };
			while (khep2->moveTo(dest2))
				;
			khep2->rotate(boutDeLigne);
			int status = 0;
			pid_t o = wait(&status);
			BobbyUtils::takeSemaphore(tacheFilleKiller);
			BobbyUtils::takeSemaphore(sm_console);
			cout << "TFK Replacement pris" << endl;
			BobbyUtils::giveSemaphore(sm_console);

			BobbyUtils::giveSemaphore(tacheFilleKiller);

			BobbyUtils::takeSemaphore(sm_console);
			cout << "TFK Replacement rendu" << endl;
			BobbyUtils::giveSemaphore(sm_console);
			exit(0);
		}
	} else {
		return rpid;
	}
}
