/*
 * ImageProcessor.cpp
 *
 *  Created on: 6 janv. 2011
 *      Author: robot1
 */

using namespace std;
#include <iostream>
#include <errno.h>
#include <sys/msg.h>

//------------------------------------------------------ Include personnel
#include "ImageProcessor.h"
#include "Point.h"

//------------------------------------------------------------- Constantes
const int NOMBRE_ITERATION_CLUSTERING = 10;
const int TAILLE_RECTANGLE_KHEPERA = 15;
const int TEMPORISATION = 20;

//---------------------------------------------------- Variables de classe
struct t_info {
	int x_ball;
	int y_ball;

	int k1_f_x;
	int k1_f_y;
	int k1_x;
	int k1_y;

	int k2_f_x;
	int k2_f_y;
	int k2_x;
	int k2_y;
};

static s_position posBalle;
static s_position posK1avant;
static s_position posK1arriere;
static s_position posK2avant;
static s_position posK2arriere;
static t_info info;
static int tolerance_rouge = 100;
static int tolerance_blanc = 130;
static int tolerance_bleu = 45;
static Point<int> barycentre_1(-1, -1);
static Point<int> barycentre_2(-1, -1);
static Point<int> barycentre(0, 0);
static int corners = 0;
static Point<int> p_corners[4];
static bool waiting_corners = true;
//----------------------------------------------------------- Types privés


//----------------------------------------------------------------- PUBLIC
//-------------------------------------------------------- Fonctions amies

//----------------------------------------------------- Méthodes publiques
void on_mouse(int event, int x, int y, int flags, void* param) {
	if (event == CV_EVENT_LBUTTONDOWN) {
		p_corners[corners].x = x;
		p_corners[corners].y = y;
		corners++;
		waiting_corners = corners < 4;
	}
}

//void ImageProcessor::InitField(Point <int> * bottomLeft, Point <int> * bottomRight, Point <int> * topRight, Point <int> * topLeft)
void ImageProcessor::InitField(CvCapture* capture) {
	//CvCapture* capture = cvCaptureFromCAM(-1);
	if (!capture) {

		cout << "pas de capture" << endl;

	}
	//return (ERROR_IMAGE);
	cvNamedWindow("Terrain", 1);
	cvSetMouseCallback("Terrain", on_mouse);
	IplImage * frame = 0;

	while (waiting_corners) {
		frame = cvQueryFrame(capture);
		if (!frame)
			continue;

		cvShowImage("Terrain", frame);

		char c = cvWaitKey(TEMPORISATION);
		if (c == 27)
			break;
	}
	//cvReleaseCapture(&capture);
	int width = (int) cvGetCaptureProperty(capture, CV_CAP_PROP_FRAME_WIDTH);
	int height = (int) cvGetCaptureProperty(capture, CV_CAP_PROP_FRAME_HEIGHT);
	cvDestroyWindow("Terrain");
}

void ImageProcessor::Run(CvCapture* capture) {
	// Lancement de la capture
	//CvCapture* capture = cvCaptureFromCAM(-1);

	int sm_console = BobbyUtils::getSemaphore(STATE_SEM_CONSOLE);
	int videoKiller = BobbyUtils::getSemaphore(STATE_SEM_VIDEOKILLER);
	int sm_protector = BobbyUtils::getSemaphore(STATE_SEM_FILENAME);

	mem_struct* sm_etatjeu = (mem_struct*) BobbyUtils::getSharedMemory(
			STATE_MEMORY_FILENAME, sizeof(mem_struct));

	if (!capture)
		return;

	int width = (int) cvGetCaptureProperty(capture, CV_CAP_PROP_FRAME_WIDTH);
	int height = (int) cvGetCaptureProperty(capture, CV_CAP_PROP_FRAME_HEIGHT);

	cvNamedWindow("Rouge", 1);
	cvNamedWindow("Bleu", 1);
	cvNamedWindow("Blanc", 1);
	cvCreateTrackbar("Tolerance", "Rouge", &tolerance_rouge, 256, 0);
	cvCreateTrackbar("Tolerance", "Bleu", &tolerance_bleu, 256, 0);
	cvCreateTrackbar("Tolerance", "Blanc", &tolerance_blanc, 256, 0);
	cvNamedWindow("Frame", 1);
	cvNamedWindow("Transformee", 1);
	// Récupération & Traitement des images
	IplImage * frame = 0;
	IplImage * image = 0;
	CvMat* mmat = cvCreateMat(3, 3, CV_32FC1);
	// Image en perspective
	CvPoint2D32f * c2;
	CvPoint2D32f * c1 =
			(&cvPoint2D32f(p_corners[0].x, p_corners[0].y), &cvPoint2D32f(
					p_corners[1].x, p_corners[1].y), &cvPoint2D32f(
					p_corners[2].x, p_corners[2].y), &cvPoint2D32f(
					p_corners[3].x, p_corners[3].y));

	while (BobbyUtils::checkSemaphore(videoKiller) == -1) {
		frame = cvQueryFrame(capture);
		if (!frame)
			continue;

		if (!image) {
			image = cvCreateImage(cvSize(width, height), 8, 3);
			image->origin = frame->origin;
			// Image souhaitee
			c2 = (&cvPoint2D32f(image->width, image->height), &cvPoint2D32f(
					image->width, 0), &cvPoint2D32f(0, 0), &cvPoint2D32f(0,
					image->height));
		}
		//cvCopy(frame,image,0);

		// Calcul de la matrice de correspondance
		mmat = cvGetPerspectiveTransform(c1, c2, mmat);
		cvWarpPerspective(frame, image, mmat);

		ImageProcessor::findBall(image);
		cvCircle(image, cvPoint(barycentre.y, barycentre.x),
				TAILLE_RECTANGLE_KHEPERA, CV_RGB(0,255,0), 3);
		ImageProcessor::findKheperas(image);
		cvCircle(image, cvPoint(barycentre_1.y, barycentre_1.x),
				TAILLE_RECTANGLE_KHEPERA, CV_RGB(0,0,255), 3);
		cvCircle(image, cvPoint(barycentre_2.y, barycentre_2.x),
				TAILLE_RECTANGLE_KHEPERA, CV_RGB(255,0,0), 3);

		cvCircle(image, cvPoint(600, 70), 10, CV_RGB(120,120,120));
		cvCircle(image, cvPoint(600, 400), 10, CV_RGB(120,120,120));
		int largeurIm = image->width;
		int longeurIm = image->height;
		//s_position posBalle = s_position {longeurIm-info.x_ball,largeurIm-info.y_ball};

		//cout << "Envoyé : X" << posBalle.x << "Y" << posBalle.y << endl;
		//		Elem posdirRob1;
		//		Elem posdirRob2;
		//		posdirRob1.setPosition(s_position {largeurIm-barycentre_1.x, longeurIm-barycentre_1.y});
		//		posdirRob2.setPosition(s_position {largeurIm-barycentre_2.x, longeurIm-barycentre_2.y});
		//
		//		Elem * posdirRobs[2];
		//		posdirRobs[0] = &posdirRob1;
		//		posdirRobs[1] = &posdirRob2;
		mem_struct informations = BobbyUtils::traitementInfos(posBalle,
				posK1avant, posK1arriere, posK2avant, posK2arriere);

		BobbyUtils::takeSemaphore(sm_protector);
		//std::cout << "On prend le token depuis le traitement video"
		//<< std::endl;
		*sm_etatjeu = informations;
		BobbyUtils::giveSemaphore(sm_protector);
		//std::cout << "On rend le token depuis le traitement video" << std::endl;

		cvShowImage("Frame", frame);
		cvShowImage("Transformee", image);

		cvWaitKey(TEMPORISATION);
	}
	BobbyUtils::takeSemaphore(sm_console);
	cout << "video VideoKiller pris " << endl;
	std::cout << "IMAGE PROCESSOR STOP!!" << std::endl;
	BobbyUtils::giveSemaphore(sm_console);

	BobbyUtils::giveSemaphore(videoKiller);

	BobbyUtils::takeSemaphore(sm_console);
	cout << "video VideoKiller rendu " << endl;
	BobbyUtils::giveSemaphore(sm_console);

	BobbyUtils::takeSemaphore(sm_console);
	cout << "fin" << endl;
	BobbyUtils::giveSemaphore(sm_console);
}

//------------------------------------------------- Surcharge d'opérateurs

//-------------------------------------------- Constructeurs - destructeur


//------------------------------------------------------------------ PRIVE

//----------------------------------------------------- Méthodes protégées
void ImageProcessor::findBall(const IplImage * const image) {
	int image_step = image->widthStep;
	int image_channels = image->nChannels;
	uchar * image_data = (uchar *) image->imageData;

	IplImage * filtered = cvCreateImage(cvSize(image->width, image->height), 8,
			1);
	filtered->origin = image->origin;
	int filtered_step = filtered->widthStep;
	int filtered_channels = filtered->nChannels;
	uchar * filtered_data = (uchar *) filtered->imageData;

	// On ne garde que la couleur rouge
	for (int i = 0; i < image->height; i++) {
		for (int j = 0; j < image->width; j++) {
			if (((image_data[i * image_step + j * image_channels + 2])
					> (tolerance_rouge + image_data[i * image_step + j
							* image_channels])) && ((image_data[i * image_step
					+ j * image_channels + 2]) > (tolerance_rouge
					+ image_data[i * image_step + j * image_channels + 1])))
				filtered_data[i * filtered_step + j * filtered_channels] = 255;
			else
				filtered_data[i * filtered_step + j * filtered_channels] = 0;
		}
	}

	cvErode(filtered, filtered, 0, 2);

	// On recherche le barycentre des points conservés
	int sum_x = 0;
	int sum_y = 0;
	int count = 0;
	for (int i = 0; i < image->height; i++) {
		for (int j = 0; j < image->width; j++) {
			if (filtered_data[i * filtered_step + j * filtered_channels] == 255) {
				sum_x += i;
				sum_y += j;
				count++;
			}
		}
	}
	if (count != 0) {
		barycentre.x = (int) (sum_x / count);
		barycentre.y = (int) (sum_y / count);
		//		ball->UpdatePosition(barycentre);
		info.x_ball = barycentre.y;
		info.y_ball = barycentre.x;
		posBalle.x = LARGEUR_TERRAIN_X - barycentre.x;
		posBalle.y = LONGUEUR_TERRAIN_Y - barycentre.y;

		cvShowImage("Rouge", filtered);
	}
	cvReleaseImage(&filtered);
}

void ImageProcessor::findKheperas(const IplImage * const image) {
	int image_step = image->widthStep;
	int image_channels = image->nChannels;
	uchar * image_data = (uchar *) image->imageData;

	IplImage * filtered = cvCreateImage(cvSize(image->width, image->height), 8,
			1);
	filtered->origin = image->origin;
	int filtered_step = filtered->widthStep;
	int filtered_channels = filtered->nChannels;
	uchar * filtered_data = (uchar *) filtered->imageData;

	// On ne garde que la couleur bleue
	for (int i = 0; i < image->height; i++) {
		//		for (int j = image->width / 2; j < image->width; j++)
		for (int j = image->width / 2; j < image->width; j++) {
			if (((image_data[i * image_step + j * image_channels])
					> (tolerance_bleu + image_data[i * image_step + j
							* image_channels + 1])) && ((image_data[i
					* image_step + j * image_channels]) > (tolerance_bleu
					+ image_data[i * image_step + j * image_channels + 2])))
				filtered_data[i * filtered_step + j * filtered_channels] = 255;
			else
				filtered_data[i * filtered_step + j * filtered_channels] = 0;
		}
	}
	//cvErode(filtered,filtered,0,2);
	// Clusterisation sur deux points : récupération de la position des deux Kheperas
	Point<int> point;
	int sum_1_x;
	int sum_1_y;
	int count_1;
	int sum_2_x;
	int sum_2_y;
	int count_2;
	for (int h = 0; h < NOMBRE_ITERATION_CLUSTERING; h++) {
		sum_1_x = 0;
		sum_1_y = 0;
		sum_2_x = 0;
		sum_2_y = 0;
		count_1 = 0;
		count_2 = 0;

		for (int i = 0; i < filtered->height; i++) {
			for (int j = image->width / 2; j < filtered->width; j++) {
				if (filtered_data[i * filtered_step + j * filtered_channels]
						== 255) {
					if (barycentre_1.x == -1) {
						barycentre_1.x = i;
						barycentre_1.y = j;
						sum_1_x = i;
						sum_1_y = j;
						count_1++;
					} else if (barycentre_2.x == -1) {
						barycentre_2.x = i;
						barycentre_2.y = j;
						sum_2_x = i;
						sum_2_y = j;
						count_2++;
					} else {
						// Il faut déterminer à quel groupe ce point appartient
						point.x = i;
						point.y = j;
						if (barycentre_1.Distance(point)
								< barycentre_2.Distance(point)) {
							sum_1_x += i;
							sum_1_y += j;
							count_1++;
						} else {
							sum_2_x += i;
							sum_2_y += j;
							count_2++;
						}
					} // else
				} // si point bleu
			} // for j
		} // for i
		if (count_1 != 0 && count_2 != 0) {
			barycentre_1.x = (int) (sum_1_x / count_1);
			barycentre_1.y = (int) (sum_1_y / count_1);
			barycentre_2.x = (int) (sum_2_x / count_2);
			barycentre_2.y = (int) (sum_2_y / count_2);
			cvShowImage("Bleu", filtered);
		}
	}// for h

	// On ne garde maintenant que la couleur blanche
	for (int i = 0; i < image->height; i++) {
		for (int j = image->width / 2; j < image->width; j++) {
			if (image_data[i * image_step + j * image_channels]
					+ tolerance_blanc >= 255 && image_data[i * image_step + j
					* image_channels + 1] + tolerance_blanc >= 255
					&& image_data[i * image_step + j * image_channels + 2]
							+ tolerance_blanc >= 255)
				filtered_data[i * filtered_step + j * filtered_channels] = 255;
			else
				filtered_data[i * filtered_step + j * filtered_channels] = 0;
		}
	}
	//cvErode(filtered,filtered,0,2);
	Point<int> bar_1_blanc(0, 0);
	Point<int> bar_2_blanc(0, 0);
	sum_1_x = 0;
	sum_1_y = 0;
	count_1 = 0;
	sum_2_x = 0;
	sum_2_y = 0;
	count_2 = 0;
	//	cout << "Barycentre 1 : X="<<barycentre_1.x<<" Y="<<barycentre_1.y<<endl;
	for (int i = barycentre_1.x - TAILLE_RECTANGLE_KHEPERA; i < barycentre_1.x
			+ TAILLE_RECTANGLE_KHEPERA; i++) {
		for (int j = barycentre_1.y - TAILLE_RECTANGLE_KHEPERA; j
				< barycentre_1.y + TAILLE_RECTANGLE_KHEPERA; j++) {
			if (filtered_data[i * filtered_step + j * filtered_channels] == 255) {
				sum_1_x += i;
				sum_1_y += j;
				count_1++;
			}
		}
	}
	if (count_1 != 0) {
		bar_1_blanc.x = (int) (sum_1_x / count_1);
		bar_1_blanc.y = (int) (sum_1_y / count_1);
		//		khep2->UpdatePosition(barycentre_2);
		//		khep2->UpdateFrontPosition(bar_2_blanc);
		info.k1_x = barycentre_1.y;
		info.k1_y = barycentre_1.x;
		info.k1_f_x = bar_1_blanc.y;
		info.k1_f_y = bar_1_blanc.x;

posK1avant	= s_position {LARGEUR_TERRAIN_X - bar_1_blanc.x,LONGUEUR_TERRAIN_Y
		- bar_1_blanc.y};
	posK1arriere = s_position {LARGEUR_TERRAIN_X - barycentre_1.x,LONGUEUR_TERRAIN_Y
		- barycentre_1.y};
	//		cout << "1avant X" << posK1avant.x << "Y" << posK1avant.y << endl;
	//		cout << "1arriere X" << posK1arriere.x << "Y" << posK1arriere.y << endl;
}
//	cout << "Barycentre 2 : X="<<barycentre_2.x<<" Y="<<barycentre_2.y<<endl;
for (int i = barycentre_2.x - TAILLE_RECTANGLE_KHEPERA; i < barycentre_2.x
		+ TAILLE_RECTANGLE_KHEPERA; i++) {
	for (int j = barycentre_2.y - TAILLE_RECTANGLE_KHEPERA; j
			< barycentre_2.y + TAILLE_RECTANGLE_KHEPERA; j++) {
		if (filtered_data[i * filtered_step + j * filtered_channels] == 255) {
			sum_2_x += i;
			sum_2_y += j;
			count_2++;
		}
	}
}
//	if(count_1!=0 && count_2 !=0)
//	{
//		bar_1_blanc.x = (int)(sum_1_x / count_1);
//		bar_1_blanc.y = (int)(sum_1_y / count_1);
//
//		bar_2_blanc.x = (int)(sum_2_x / count_2);
//		bar_2_blanc.y = (int)(sum_2_y / count_2);
//
//		Point<int> k1(info.k1_x,info.k1_y);
//		Point<int> k2(info.k2_x,info.k2_y);
//		if(k1.Distance(barycentre_1)<k2.Distance(barycentre_1))
//		{
//			info.k1_x = barycentre_1.y;
//			info.k1_y = barycentre_1.x;
//			info.k1_f_x = bar_1_blanc.y;
//			info.k1_f_y = bar_1_blanc.x;
//			info.k2_x = barycentre_2.y;
//			info.k2_y = barycentre_2.x;
//			info.k2_f_x = bar_2_blanc.y;
//			info.k2_f_y = bar_2_blanc.x;
//		}
//		else
//		{
//			info.k1_x = barycentre_2.y;
//			info.k1_y = barycentre_2.x;
//			info.k1_f_x = bar_2_blanc.y;
//			info.k1_f_y = bar_2_blanc.x;
//			info.k2_x = barycentre_1.y;
//			info.k2_y = barycentre_1.x;
//			info.k2_f_x = bar_1_blanc.y;
//			info.k2_f_y = bar_1_blanc.x;
//		}
//	}
if (count_2 != 0) {
	bar_2_blanc.x = (int) (sum_2_x / count_2);
	bar_2_blanc.y = (int) (sum_2_y / count_2);
	//		khep2->UpdatePosition(barycentre_2);
	//		khep2->UpdateFrontPosition(bar_2_blanc);
	info.k2_x = barycentre_2.y;
	info.k2_y = barycentre_2.x;
	info.k2_f_x = bar_2_blanc.y;
	info.k2_f_y = bar_2_blanc.x;
	posK2avant = {LARGEUR_TERRAIN_X - bar_2_blanc.x,LONGUEUR_TERRAIN_Y
		- bar_2_blanc.y};
	posK2arriere = {LARGEUR_TERRAIN_X - barycentre_2.x,LONGUEUR_TERRAIN_Y
		- barycentre_2.y};
	//		cout << "2avant X" << posK2avant.x << "Y" << posK2avant.y << endl;
	//		cout << "2arriere X" << posK2arriere.x << "Y" << posK2arriere.y << endl;

}

if (count_1 < 2)
barycentre_1.x = -1;
if (count_2 < 2)
barycentre_2.x = -1;

cvShowImage("Blanc", filtered);
cvReleaseImage(&filtered);
}
//------------------------------------------------------- Méthodes privées

